from gensim.models.phrases import Phrases


class NGramGeneration:

    @staticmethod
    def generate_bi_trigrams(input_data):
        # Add bigrams and trigrams (only ones that appear 2 times or more)
        input_data['bigrams_tokens'] = None
        input_data['bigrams_text'] = None
        input_data['trigrams_tokens'] = None
        input_data['trigrams_text'] = None
        input_data['fourgrams_tokens'] = None
        input_data['fourgrams_text'] = None
        input_data['fivegrams_tokens'] = None
        input_data['fivegrams_text'] = None
        bigram = Phrases(input_data['normalized_body_tokens'], min_count=1, delimiter='_')
        trigram = Phrases(bigram[input_data['normalized_body_tokens']], min_count=1, delimiter='_')
        fourgram = Phrases(trigram[bigram[input_data['normalized_body_tokens']]], min_count=1, delimiter='_')
        fivegram = Phrases(fourgram[trigram[bigram[input_data['normalized_body_tokens']]]], min_count=1, delimiter='_')
        for idx, row in input_data.iterrows():
            bigrams_ = [b for b in bigram[row['normalized_body_tokens']] if b.count('_') == 1]
            trigrams_ = [t for t in trigram[bigram[row['normalized_body_tokens']]] if t.count('_') == 2]
            fourgrams_ = [t for t in fourgram[trigram[bigram[row['normalized_body_tokens']]]] if t.count('_') == 3]
            fivegrams_ = [t for t in fivegram[fourgram[trigram[bigram[row['normalized_body_tokens']]]]] if t.count('_') == 4]
            
            input_data.at[idx, 'bigrams_tokens'] = bigrams_
            input_data.at[idx, 'bigrams_text'] = ','.join(bigrams_)
            
            input_data.at[idx, 'trigrams_tokens'] = trigrams_
            input_data.at[idx, 'trigrams_text'] = ','.join(trigrams_)
            
            input_data.at[idx, 'fourgrams_tokens'] = fourgrams_
            input_data.at[idx, 'fourgrams_text'] = ','.join(fourgrams_)
            
            input_data.at[idx, 'fivegrams_tokens'] = fivegrams_
            input_data.at[idx, 'fivegrams_text'] = ','.join(fivegrams_)

        return input_data
