import os
import sqlite3
import time
import warnings

import pandas as pd


from TopicModeling import TopicModeling

warnings.filterwarnings("ignore")


def main():
    start = time.time()

    # ###############################################################
    print(" --  -- Started: Read Input Data --  -- ")
    connection = sqlite3.connect('C:/Projects/StackOverflow_MobileSecurity/data/dataset.sqlite')
    input_data = pd.read_sql_query('select * from Normalized_Body', connection)
    # ###############################################################

    # ###############################################################
    print(" --  -- Started: Topic Assignment --  -- ")
    input_data['normalized_body_tokens'] = None
    for i, row in input_data.iterrows():
        input_data.at[i, 'normalized_body_tokens'] = row['normalized_body'].split()


    unigram_model = 'C:/Projects/StackOverflow_MobileSecurity/data/result_model_7_LdaModel.bin'
    unigram_dictionary = 'C:/Projects/StackOverflow_MobileSecurity/data/result_dictionary.bin'
    topic_modeling = TopicModeling()
    topic_data = topic_modeling.generate_document_topic(input_data, 'normalized_body_tokens', unigram_model, unigram_dictionary)
    conn = sqlite3.connect('C:/Projects/StackOverflow_MobileSecurity/data/input_topics_assigned_unigrams_7.sqlite')
    temp_dataset = topic_data.copy(deep=True)
    temp_dataset.drop('normalized_body_tokens', 1, inplace=True)
    temp_dataset.to_sql('input_topics_assigned_unigrams', conn, if_exists='replace', index=True)


    end = time.time()
    print("Process completed in " + str(end - start) + " seconds")


if __name__ == "__main__":
    main()